module Pagseguro
  module Charge
    # Credit card data

    class Address
      attr_accessor :country,
                    :region,
                    :region_code,
                    :city,
                    :postal_code,
                    :street,
                    :number,
                    :locality


      def initialize(args = {})
        @country = args[:country]
        @region = args[:region]
        @region_code = args[:region_code]
        @city = args[:city]
        @postal_code = args[:postal_code]
        @street = args[:street]
        @number = args[:number]
        @locality = args[:locality]
      end

      def to_json(*options)
        hash = as_json(*options)
        hash.reject! {|k,v| v.nil?}
        hash.to_json(*options)
      end

      def self.fill_from_json(data)
        return if data.nil?

        address = new
        address.country = data["country"]
        address.region = data["region"]
        address.region_code = data["region_code"]
        address.city = data["city"]
        address.postal_code = data["postal_code"]
        address.street = data["street"]
        address.number = data["number"]
        address.locality = data["locality"]
        address
      end

      def as_json(options={})
        {
          country: @country,
          region: @region,
          region_code: @region_code,
          city: @city,
          postal_code: @postal_code,
          street: @street,
          number: @number,
          locality: @locality
        }
      end
    end

  end
end
