module Pagseguro
  module Charge
    # Credit card data

    class Amount
      attr_accessor :value,
                    :currency,
                    :summary

      def initialize(args = {})
        @value = args[:value]
        @currency = args[:currency]
        @summary = args[:summary]
      end

      def to_json(*options)
        hash = as_json(*options)
        hash.reject! {|k,v| v.nil?}
        hash.to_json(*options)
      end

      def self.fill_from_json(data)
        return if data.nil?

        amount = new
        amount.currency = data["currency"]
        amount.value = data["value"]
        amount.summary = Summary.fill_from_json(data["summary"])
        amount

      end

      def as_json(options={})
        {
          value: @value,
          currency: @currency,
          summary: @summary
        }
      end
    end
  end
end
