module Pagseguro
  module Charge
    # Credit card data
    #
    # @attr [Long] number Credit card number
    # @attr [integer] exp_month Credit card expiration month
    # @attr [Integer] exp_year Credit card expiration year
    # @attr [String] security_code Credit card security_code
    # @attr [String] brand Credit card brand
    class Boleto
      attr_accessor :due_date,
                    :instruction_lines,
                    :holder,
                    #response
                    :id,
                    :barcode,
                    :formatted_barcode

      def initialize(args = {})
        @due_date = args[:due_date]
        @instruction_lines = args[:instruction_lines]
        @holder = args[:holder]
      end

      def to_json(*options)
        hash = as_json(*options)
        hash.reject! {|k,v| v.nil?}
        hash.to_json(*options)
      end

      def self.fill_from_json(data)
        return if data.nil?

        boleto = new
        boleto.due_date = data["due_date"]
        boleto.instruction_lines = InstructionLines.fill_from_json(data["instruction_lines"])
        boleto.holder = Holder.fill_from_json(data["holder"])
        boleto.barcode = data["barcode"]
        boleto.id = data["id"]
        boleto.formatted_barcode = data["formatted_barcode"]
        boleto
      end

      def as_json(options={})
        {
          id: @id,
          due_date: @due_date,
          instruction_lines: @instruction_lines,
          barcode: @barcode,
          formatted_barcode: @formatted_barcode,
          holder: @holder
        }
      end
    end
  end
end
