module Pagseguro
  module Charge
    # Credit card data
    #
    # @attr [Long] number Credit card number
    # @attr [integer] exp_month Credit card expiration month
    # @attr [Integer] exp_year Credit card expiration year
    # @attr [String] security_code Credit card security_code
    # @attr [String] brand Credit card brand
    class CreditCard
      attr_accessor :number,
                    :exp_month,
                    :exp_year,
                    :security_code,
                    :holder,
                    :first_digits,
                    :last_digits,
                    :brand

      def initialize(args = {})
        @security_code = args[:security_code]
        @number = args[:number]
        @exp_month = args[:exp_month]
        @exp_year = args[:exp_year]
        @holder = args[:holder]
      end

      def to_json(*options)
        hash = as_json(*options)
        hash.reject! {|k,v| v.nil?}
        hash.to_json(*options)
      end

      def self.fill_from_json(data)
        return if data.nil?

        credit_card = new
        credit_card.number = data["number"]
        credit_card.exp_month = data["exp_month"]
        credit_card.exp_year = data["exp_year"]
        credit_card.security_code = data["security_code"]
        credit_card.first_digits = data["first_digits"]
        credit_card.last_digits = data["last_digits"]
        credit_card.brand = data["brand"]
        credit_card.holder = Holder.fill_from_json(data["holder"])
        credit_card
      end

      def as_json(options={})
        {
          brand: @brand,
          number: @number,
          exp_year: @exp_year,
          exp_month: @exp_month,
          security_code: @security_code,
          last_digits: @last_digits,
          first_digits: @first_digits,
          holder: @holder
        }
      end
    end
  end
end
