module Pagseguro
  module Charge
    # Credit card data
    #
    # @attr [Long] number Credit card number
    # @attr [integer] exp_month Credit card expiration month
    # @attr [Integer] exp_year Credit card expiration year
    # @attr [String] security_code Credit card security_code
    # @attr [String] brand Credit card brand
    class Holder
      attr_accessor :name,
                    :tax_id,
                    :email,
                    :address

      def initialize(args = {})
        @name = args[:name]
        @tax_id = args[:tax_id]
        @email = args[:email]
        @address = args[:address]
      end

      def to_json(*options)
        hash = as_json(*options)
        hash.reject! {|k,v| v.nil?}
        hash.to_json(*options)
      end

      def self.fill_from_json(data)
        return if data.nil?

        holder = new
        holder.name = data["name"]
        holder.tax_id = data["tax_id"]
        holder.email = data["email"]
        holder.address = Address.fill_from_json(data["address"])
        holder
      end

      def as_json(options={})
        {
          name: @name,
          tax_id: @tax_id,
          email: @email,
          address: @address
        }
      end
    end
  end
end
