module Pagseguro
  module Charge
    # Credit card data

    class Summary
      attr_accessor :total,
                    :paid,
                    :refunded

      def initialize(args = {})
        @total = args[:total]
        @paid = args[:paid]
        @refunded = args[:refunded]
      end

      def to_json(*options)
        hash = as_json(*options)
        hash.reject! {|k,v| v.nil?}
        hash.to_json(*options)
      end

      def self.fill_from_json(data)
        return if data.nil?

        summary = new
        summary.total = data["total"]
        summary.paid = data["paid"]
        summary.refunded = data["refunded"]
        summary
      end

      def as_json(options={})
        {
          total: @total,
          paid: @paid,
          refunded: @refunded
        }
      end
    end

  end
end
